



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[Linux] PHP程序员玩转Linux系列-Nginx中的HTTPS</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[Linux] PHP程序员玩转Linux系列-Nginx中的HTTPS</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 21:04:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://www.cnblogs.com/taoshihan/p/6412542.html" rel="external nofollow noreferrer">1.PHP程序员玩转Linux系列-怎么安装使用CentOS</a></p>
<p><a href="http://www.cnblogs.com/taoshihan/p/6416320.html" rel="external nofollow noreferrer">2.PHP程序员玩转Linux系列-lnmp环境的搭建</a></p>
<p><a href="http://www.cnblogs.com/taoshihan/p/6426414.html" rel="external nofollow noreferrer">3.PHP程序员玩转Linux系列-搭建FTP代码开发环境</a></p>
<p><a href="http://www.cnblogs.com/taoshihan/p/6437468.html" rel="external nofollow noreferrer">4.PHP程序员玩转Linux系列-备份还原MySQL</a></p>
<p><a href="http://www.cnblogs.com/taoshihan/p/6515962.html" rel="external nofollow noreferrer">5.PHP程序员玩转Linux系列-自动备份与SVN</a></p>
<p><a href="http://www.cnblogs.com/taoshihan/p/6599722.html" rel="external nofollow noreferrer">6.PHP程序员玩转Linux系列-Linux和Windows安装nginx</a></p>
<p><a href="http://www.cnblogs.com/taoshihan/p/6674019.html" rel="external nofollow noreferrer">7.PHP程序员玩转Linux系列-nginx初学者引导</a></p>
<p><strong>创建一个HTTPS服务器</strong></p>
<p>在nginx.conf配置文件中,在server块里面通过listen指令指定ssl的参数,设置好服务器证书和私钥文件的路径</p>
<div>
<pre class="prettyprint linenums">server {<br />
    listen              443 ssl;<br />
    server_name         www.example.com;<br />
    ssl_certificate     www.example.com.crt;<br />
    ssl_certificate_key www.example.com.key;<br />
    ssl_protocols       TLSv1 TLSv1.1 TLSv1.2;<br />
    ssl_ciphers         HIGH:!aNULL:!MD5;<br />
    ...<br />
}
</pre>
</div>
<p>服务器证书是一个公开实体,它会被发送给每一个连接过来的客户端.私钥是一个安全实体,它应该被存储在一个限制权限的文件中.但是nginx的master进程必须能够读到该私钥文件. 私钥也可以和证书放在一个文件里面.</p>
<div>
<pre class="prettyprint linenums">ssl_certificate www.example.com.cert;<br />
ssl_certificate_key www.example.com.cert;
</pre>
</div>
<p>在这个例子里面,文件的访问权限应该被限制.尽管证书和私钥在一个文件里面,只有证书会被发送给客户端.</p>
<p>ssl_protocols 和ssl_ciphers&nbsp;指令可以被用来限制连接,只包含高版本的TLS和SSL/TLS的密码</p>
<p>从nginx&nbsp;1.0.5版本开始,nginx默认使用ssl_protocols SSLv3 TLSv1和ssl_ciphers HIGH:!aNULL:!MD5.从nginx 1.1.13 和 1.0.12&nbsp;版本开始,默认更新成了&nbsp;ssl_protocols SSLv3 TLSv1 TLSv1.1 TLSv1.2</p>
<p><strong>一个单一的HTTP和HTTPS服务</strong></p>
<p>可以配置一个服务同时支持HTTP和HTTPS请求, 在虚拟主机中使用listen指令,一个带着ssl参数,一个不带参数.</p>
<div>
<pre class="prettyprint linenums">server {<br />
    listen              80;<br />
    listen              443 ssl;<br />
    server_name         www.example.com;<br />
    ssl_certificate     www.example.com.crt;<br />
    ssl_certificate_key www.example.com.key;<br />
    ...<br />
}
</pre>
</div>
<p>在nginx&nbsp;0.7.13和更早的版本中,SSL不能被单独设置监听socket.只能通过ssl指令为全部server开启SSL,才能实现HTTP/HTTPS同时支持.为了解决这一问题,为listen指令添加了ssl参数.因此在0.7.14和之后的版本中,ssl指令不能再用了.　　</p>
<p><strong>基于名称的HTTPS服务</strong></p>
<p>一个很普遍的问题出现了,那就是解决当在一个ip地址配置监听两个或多个HTTPS服务.</p>
<div>
<pre class="prettyprint linenums">server {<br />
    listen          443 ssl;<br />
    server_name     www.example.com;<br />
    ssl_certificate www.example.com.crt;<br />
    ...<br />
}

server {<br />
    listen          443 ssl;<br />
    server_name     www.example.org;<br />
    ssl_certificate www.example.org.crt;<br />
    ...<br />
}
</pre>
</div>
<p>使用这个配置,浏览器只能接收到默认的证书,在这个例子中就是www.example.com证书.这个是因为SSL协议本身造成的.SSL的连接是在浏览器发送HTTP请求之前建立的,因此nginx不知道请求的名称.所以它只能提供默认服务的证书.</p>
<p>解决这一问题最好的方式是分配不同的IP地址给每一个HTTPS服务</p>
<div>
<pre class="prettyprint linenums">server {<br />
    listen          192.168.1.1:443 ssl;<br />
    server_name     www.example.com;<br />
    ssl_certificate www.example.com.crt;<br />
    ...<br />
}

server {<br />
    listen          192.168.1.2:443 ssl;<br />
    server_name     www.example.org;<br />
    ssl_certificate www.example.org.crt;<br />
    ...<br />
}
</pre>
</div>
<p>　　</p>
<p><strong>使用多个名称生成SSL证书</strong></p>
<p>这里有其他的方式解决上面的问题,但是每一种都有各自的缺点.一种方式是生成证书的时候更改SubjectAltName字段,比如:&nbsp;www.example.com 和 www.example.org 两个,但是这个字段有长度限制.</p>
<p>另一种方式是证书名称那里使用通配符,比如:&nbsp;*.example.org,但是 通配符名称只能用在一级子域名上.这个名称可以匹配www.example.org ,但是不能匹配example.org或 www.sub.example.org</p>
<p>这两种方式可以结合起来,在SubjectAltName字段里填上&nbsp;example.org 和 *.example.org</p>
<p>最好把多域名证书和私钥放在配置http块中,这样所有的服务都可以继承这个配置</p>
<div>
<pre class="prettyprint linenums">ssl_certificate     common.crt;<br />
ssl_certificate_key common.key;

server {<br />
    listen          443 ssl;<br />
    server_name     www.example.com;<br />
    ...<br />
}

server {<br />
    listen          443 ssl;<br />
    server_name     www.example.org;<br />
    ...<br />
}
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qydmrjq.html">SpringMVC学习记录1</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyynvmq.html">Java &lpar;JVM&rpar; Memory Model &ndash; Memory Management in Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qww1kyq.html">Convert&period;ToInt32&comma;int&period;Parse&comma;int&period;TryParse&comma;&lpar;int&rpar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8egl3z9.html">select 练习4</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m31lo9.html">unix&sol;linux进程详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wmgdoq.html">PHP正则表达式匹配中文字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o4ejy9.html">MySQL基础学习之数据表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn10p438.html">java15  IO装饰设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnvvg6q.html">&lbrack;Leetcode&rsqb; Validate BST</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmxej9.html">Android Camera Api的心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzx77e8.html">python3 python2 import 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4wd7j9.html">远程连接报错&OpenCurlyDoubleQuote;This could be due to CredSSP encryption oracle remediation&period;&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv24kvj9.html">构建Redis主从镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjwvy59.html">一类n阶微分方程转1阶微分方程组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2n20d8.html">linux读写锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1j2ek9.html">qt&period;qpa&period;plugin&colon; Could not find the Qt platform plugin &amp;quot&semi;windows&amp;quot&semi; in &amp;quot&semi;&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp5yre9.html">Intellij IDEA使用Maven搭建spark开发环境（scala）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4y3req.html">XML Web Service架构图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9024ey3q.html">html-图像标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e2yxk9.html">MVC5开发环境的配置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1kjr029.html">JavaScript中数组Array方法详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj54jlq.html">Ceph部署（二）RGW搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zn7nj9.html">LAMP部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zojr4xq.html">hashMap4种遍历方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj0rzz8.html">css样式表1  2017-03-11</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoj34xq.html">单源最短路径问题之dijkstra算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gedgnl8.html">jquery知识点复习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj04gy8.html">Markdown轻量级标记语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj5lmxq.html">Java日期获取需求大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mepx26q.html">eclipse中以debug方式启动tomcat报错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
